# Python type hints for the xAAL library

from typing import TYPE_CHECKING, TypeVar

if TYPE_CHECKING:
    from .devices import Device, Attributes, Attribute
    from .engine import Engine
    from .aioengine import AsyncEngine
    from .bindings import UUID

DeviceT = TypeVar("DeviceT", bound="Device")
AttributeT = TypeVar("AttributeT", bound="Attribute")
AttributesT = TypeVar("AttributesT", bound="Attributes")
EngineT = TypeVar("EngineT", bound="Engine")
AsyncEngineT = TypeVar("AsyncEngineT", bound="AsyncEngine")

UUIDT = TypeVar("UUIDT", bound="UUID")
